package eclipsejogl;

import com.jogamp.newt.event.MouseEvent;
import com.jogamp.newt.event.MouseListener;
import com.jogamp.opengl.GL2;
import com.jogamp.opengl.GLAutoDrawable;
import com.jogamp.opengl.GLEventListener;
import com.jogamp.opengl.glu.GLU;
import com.jogamp.opengl.util.gl2.GLUT;

public class GLRenderer implements GLEventListener, MouseListener {

	float[] posizione;
	float a = 0.0f;
	float xLuce = 0, yLuce = 0;

	@Override
	public void init(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();

		float[] ambiente = new float[] { 1, 1, 1, 1 };
		float[] diffusa = new float[] { 1, 1, 1, 1 };
		float[] speculare = new float[] { 1, 1, 1, 1 };
//		float[] posizione = new float[] { 0, 10, 10, 1 };

		// imposta le caratteristiche della sorgente di luce 0
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_AMBIENT, ambiente, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_DIFFUSE, diffusa, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_SPECULAR, speculare, 0);
//		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_POSITION, posizione, 0);
		// attiva la sorgente di luce 0
		gl.glEnable(GL2.GL_LIGHT0);
		// attiva l'iluminazione
		gl.glEnable(GL2.GL_LIGHTING);
		// attiva il test di profondit per disegnare solo parti visibili
		gl.glEnable(GL2.GL_DEPTH_TEST);
		// imposta il colore di sfondo
		gl.glClearColor(0, 0, 0.1f, 0);
	}

	@Override
	public void dispose(GLAutoDrawable drawable) {
	}

	@Override
	public void display(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();
		GLUT glut = new GLUT();

		// cancella l'immagine e il buffer per il test di profondit
		gl.glClear(GL2.GL_COLOR_BUFFER_BIT | GL2.GL_DEPTH_BUFFER_BIT);

		for (int x=-10; x<10; x+=2)
			for (int y=-10; y<10; y+=2) {
				// sfera
				gl.glLoadIdentity();
				gl.glRotatef(a, 0, 0, 1);
				gl.glTranslatef(x, y, 0);
				glut.glutSolidSphere(1, 36, 18);
			}

		// sposta la luce
		gl.glLoadIdentity();
		posizione = new float[] { xLuce, yLuce, 2, 1 };
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_POSITION, posizione, 0);
		
		// incrementa l'angolo di rotazione di 1
//		a += 1.0f;
	}

	@Override
	public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h) {
		GL2 gl = drawable.getGL().getGL2();
		GLU glu = new GLU();

		// imposta la matrice di trasformazione per la proiezione
		gl.glMatrixMode(GL2.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluPerspective(45, (float) w / h, 1, 50);
		glu.gluLookAt(0, 0, 15, 0, 0, 0, 0, 1, 0);

		// imposta la matrice di trasformazione per gli oggetti
		gl.glMatrixMode(GL2.GL_MODELVIEW);
		gl.glLoadIdentity();
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseMoved(MouseEvent e) {
		xLuce = e.getX()/100.0f; 
		yLuce = e.getY()/100.0f; 
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseWheelMoved(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

}
