package eclipsejogl;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JToggleButton;
import javax.swing.SpringLayout;

import com.jogamp.newt.opengl.GLWindow;
import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.util.FPSAnimator;

public class Main extends JFrame {

    GLWindow window;
    FPSAnimator animator;
    GLRenderer renderer;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		setTitle("Eclipse JOGL");
		setBounds(100, 100, 300, 120);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		SpringLayout springLayout = new SpringLayout();
		getContentPane().setLayout(springLayout);
		
		JButton btnShow = new JButton("Show");
		btnShow.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
		        window.setVisible(true);
		    }
		});
		springLayout.putConstraint(SpringLayout.NORTH, btnShow, 10, SpringLayout.NORTH, getContentPane());
		springLayout.putConstraint(SpringLayout.WEST, btnShow, 10, SpringLayout.WEST, getContentPane());
		getContentPane().add(btnShow);
		
		JButton btnHide = new JButton("Hide");
		btnHide.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
		        window.setVisible(false);
			}
		});
		springLayout.putConstraint(SpringLayout.NORTH, btnHide, 0, SpringLayout.NORTH, btnShow);
		springLayout.putConstraint(SpringLayout.WEST, btnHide, 6, SpringLayout.EAST, btnShow);
		getContentPane().add(btnHide);
		
		JToggleButton tglbtnFullscreen = new JToggleButton("Fullscreen");
		tglbtnFullscreen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
		        window.setFullscreen(tglbtnFullscreen.isSelected());
			}
		});
		springLayout.putConstraint(SpringLayout.NORTH, tglbtnFullscreen, 0, SpringLayout.NORTH, btnShow);
		springLayout.putConstraint(SpringLayout.WEST, tglbtnFullscreen, 6, SpringLayout.EAST, btnHide);
		getContentPane().add(tglbtnFullscreen);
		
		JButton btnStart = new JButton("Start");
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
		        animator.start();
		    }
		});
		springLayout.putConstraint(SpringLayout.NORTH, btnStart, 6, SpringLayout.SOUTH, btnShow);
		springLayout.putConstraint(SpringLayout.WEST, btnStart, 0, SpringLayout.WEST, btnShow);
		getContentPane().add(btnStart);
		
		JButton btnStop = new JButton("Stop");
		btnStop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
		        animator.stop();
			}
		});
		springLayout.putConstraint(SpringLayout.NORTH, btnStop, 0, SpringLayout.NORTH, btnStart);
		springLayout.putConstraint(SpringLayout.WEST, btnStop, 6, SpringLayout.EAST, btnStart);
		getContentPane().add(btnStop);

        window = GLWindow.create(new GLCapabilities(GLProfile.getDefault()));
        window.setTitle("GLWindow");
        window.setSize(400, 300);
        renderer = new GLRenderer();
        window.addGLEventListener(renderer);
        window.addMouseListener(renderer);
        animator = new FPSAnimator(window, 60, false);
	}
}
